config/routes.rb
Rails.application.routes.draw do

  root 'static_pages#home'
  get 'static_pages/help'
  get 'sessions/new'


  get "/about", to: 'static_pages#about'
  get "/contact", to: 'static_pages#contact'
  get "/help", to: 'static_pages#help'


  get '/login', to: 'sessions#new'
  post '/login', to: 'sessions#create'
  delete '/logout', to: 'sessions#destroy'

  get '/search', to: 'questions#search'

  post '/upvote', to: 'votes#up_vote'
  post '/downvote', to: 'votes#down_vote'

  resources :users
  resources :account_activations , only: [:edit]
  resources :password_resets , only:[:new, :create, :edit, :update]
  resources :questions , except: [:create]

  resources :answers ,except: [:index,:show]
  resources :tags, only: [:index, :show]
  resources :comments, except: [:new, :index, :show]
end

app/models/question.rb
class Question < ApplicationRecord
  belongs_to :user, inverse_of: :questions
  has_many :answers, inverse_of: :question, dependent: :destroy
  has_and_belongs_to_many :tags
  include Commentable, Votable

  validates :header , presence: true, length: {maximum: 100}
  validates :content, presence: true, length: {maximum: 30000,too_long: "%{count} characters is the maximum allowed" }
  validates :user_id, presence: true

  def add_tags(args)
    args.each do |arg|
      tag=Tag.find_by(name: arg)
      if tag.nil?
        self.tags<<Tag.create(name:arg)
      else
        self.tags<<tag
      end
    end
  end

  def upvote
    increment!(:vote_rep,1)
  end

  def downvote
    decrement!(:vote_rep,1)
  end


  private

  def picture_size
    if picture.size>5.megabyte
      errors.add(:picture , "should be less than 5MB")
    end
  end

end

app/controllers/questions_controller.rb
class QuestionsController < ApplicationController
  include QuestionsHelper
  before_action :logged_in_user, only: [:create, :destroy]
  before_action :correct_user, only: :destroy


  def index
    @questions=Question.all.paginate(page: params[:page])
  end

  def new
    @question=Question.new
  end

  def create
    @question=current_user.questions.build(question_params)
    add_tags(params[:tags][:tags])
    if @question.save

      flash[:success] = "Question created!"
      redirect_to @question
    else
      @feed_items = []
      redirect_to new_question_path
    end
  end

  def search
    @questions = search_ques(params[:search])
    if  @questions.empty?
      flash[:info] = "Couldn\'t find #{params[:search]}"
    else
      @questions = @questions.paginate(page: params[:page])
    end
  end



  def show
    @question=Question.find(params[:id])
    @answers=@question.answers
    @tags=@question.tags
  end



  def edit
    @question=Question.find(params[:id])
  end



  def update
    @question=Question.find(params[:id])
    @question.update(question_params)
    if @question.update(question_params)
      flash[:success] = "Question updated"
      redirect_to @question
    else
      render 'edit'
    end
  end

  def destroy
    puts "hello"
    user=@question.user
    @question.destroy
    user_rep(user)
    flash[:success] = "Question deleted"
    redirect_to  root_url
  end



  private

  def add_tags(args)
    args = args.split(" ")
    args.each do |arg|
      tag=Tag.find_by(name: arg)
      if tag.nil?
        @question.tags<<Tag.create(name:arg)
      else
        @question.tags<<tag
      end
    end
  end

  def question_params
    params.require(:question).permit(:header, :content, :picture)
  end

  def correct_user
    @question = current_user.questions.find_by(id: params[:id])
    redirect_to root_url if @question.nil?
  end

end

app/helpers/questions_helper.rb
module QuestionsHelper
  def search_ques(search_string)
    Question.where("header LIKE ? ", "%#{search_string}%")
  end
end

app/views/questions/_question.html.erb
<ul class="questions">
  <li><h4><%= link_to question.header, question %></h4>
    <h5><%= question.content.truncate(100)%></h5></li>
</ul>

app/views/questions/_questions_form.html.erb
<div class="col col-xl-20 ques">
  <%= form_for(@question , html: {multipart: true}) do |f| %>
    <div class="field">
      <%= f.text_field :header, placeholder: "What is your question?" %>
    </div>
    <div class="field">
      <%= f.text_area :content, placeholder: "Explain your question here!!" %>
    </div>
    <div class="field">
      <%= text_field :tags, :tags, placeholder: "Question Tags go here!!!" %>
    </div>
    <%= f.submit "Ask ", class: "btn btn-primary" %>
  <% end %>
</div>

app/views/questions/index.html.erb
<% provide(:title, 'All questions') %>
<h1>All  Questions</h1>
<%= will_paginate %>
<ul class="questions">
  <% @questions.each do |question| %>
    <li><h4><%= link_to question.header, question %></h4>
      <h5><%= question.content.truncate(100) %></h5></li>
  <% end %>
</ul>
<%= will_paginate %>

app/views/questions/new.html.erb
<% provide(:title, 'Ask Question') %>
<h1>Ask Question</h1>
<%= render 'questions/questions_form' %>

app/views/questions/search.html.erb
<% provide(:title, "Search") %>

<h1>Search</h1>

<p>
  <%= form_for search_path , method: "get" do %>
    <%= label_tag(:search, "Search for:")  %>
    <%= text_field_tag(:search)%>
    <%= submit_tag "Search", class: "btn btn-primary" %>
  <% end %>
</p>


<ul class="questions">
  <% @questions.each do |question| %>
    <li><h4><%= link_to question.header, question %></h4>
      <h5><%= question.content.truncate(100)%></h5></li>
  <% end %>
</ul>

<%= will_paginate %>

app/views/questions/show.html.erb
<% provide(:title, 'Ques_Show') %>
<div class="question_box">
  <h1><%= @question.header %></h1>
  <h3>Tags</h3>
  <%@tags.each do |tag| %>
    <span class="badge badge-secondary"><%= link_to tag.name, tag %></span>
  <%end %>
  </br>
  <h2><%= simple_format(@question.content)%></h2>

<% if logged_in? %>
  <% if a=current_user.votes.find_by(votable:@question) %>
    <% if a.vote.nil? %>
    <%= link_to "Upvote",upvote_path(votable_id:@question.id,votable_type:"Question",user_id:current_user.id), method: :post, remote: true %>
      <h3> <%= @question.votes_rep %> </h3>
    <%= link_to "Downvote", downvote_path(votable_id:@question.id,votable_type:"Question",user_id:current_user.id),method: :post %>
    <% elsif a.vote %>
      <%= link_to "Upvoted", upvote_path(votable_id:@question.id, votable_type:"Question", user_id:current_user.id), method: :post %>
      <h3><%= @question.votes_rep %></h3>
       <%= link_to "Downvote",downvote_path(votable_id:@question.id,votable_type:"Question",user_id:current_user.id),method: :post %>
      <%else %>
      <%= link_to "Upvote", upvote_path(votable_id:@question.id,votable_type:"Question",user_id:current_user.id),method: :post %>
      <h3> <%= @question.votes_rep%> </h3>
      <%= link_to "Downvoted",downvote_path(votable_id:@question.id,votable_type:"Question",user_id:current_user.id),method: :post %>
    <%end %>
    <%else %>
    <%= link_to "Upvote", upvote_path(votable_id:@question.id,votable_type:"Question",user_id:current_user.id),method: :post %>
    <h3> <%= @question.votes_rep %> </h3>
    <%= link_to "Downvote", downvote_path(votable_id:@question.id,votable_type:"Question",user_id:current_user.id),method: :post %>
  <%end %>
    <%end %>


  <span class="user"><%= link_to @question.user.name, @question.user %> </span><span class="timestamp">
Posted <%= time_ago_in_words(@question.created_at) %> ago.
  <% if current_user?(@question.user) %>
<%= link_to "delete", @question , method: :delete, data: { confirm: "You sure?" } %></span>

<% end %>
</div>


  <%if logged_in? %>
    <%=render "answers/answer_form",  question: @question%>
  <%end %>

  <% if @answers.any? %>
      <h3><a>Answers (<%= @answers.count %>)</a></h3>
    <ul class="answers">
          <%=render @answers%>
    </ul>
<%end %>